# -*- coding: utf-8 -*-
"""
Created on Thu Aug 25 14:14:07 2016

@author: petrovpg
"""


import numpy as np
import matplotlib.pyplot as plt
import csv
import matplotlib as mp
from scipy.optimize import curve_fit
from matplotlib.lines import Line2D

#from matplotlib import rc
#plt.close('all')

#mp.rcParams.update({'font.size': 6, 'font.family': 'arial', 'legend.fontsize':'small'})
##axis params
#mp.rcParams.update({'figure.figsize': [170.0, 100], 'figure.dpi': 300, 'savefig.dpi': 300})
##line style params
#mp.rcParams.update({'lines.markersize': 2,'lines.linewidth':0.5, 'axes.linewidth': 0.5, 'lines.markeredgewidth': 0.1, 'grid.linewidth': 0.2, 'xtick.major.size': 1, 'ytick.major.size': 1})
##subplot params
#mp.rcParams.update({'figure.subplot.top': 0.90,  'figure.subplot.bottom': 0.20,'figure.subplot.left': 0.15, 'figure.subplot.right': 0.85, 'figure.subplot.hspace': 0.5, 'figure.subplot.wspace': 0.2})


#define function to read a column from the CSV file

#slitscanning_vertical_noconduit_20161201_1.csv - vertical, no conduit
#slitscanning_noconduit_goodresults_20161130.csv - horizontal scanning no conduit

def read_col(filename,l):
  C = []
  with open(filename) as csvfile:
        spamreader = csv.reader(csvfile, delimiter=',')
        for row in spamreader:
           C = C +[row[l]]
        CC = np.array(C[0:],'float64')
        return CC


def sort_array(filename,n,m1,m2):        
    x = [[]]*n
    P = [[]]*n
    Sq = [[]]*n
    #Sn = [[]]*5
    #Data = []        
    for i in np.arange(n):
        x[i].append(read_col(filename,0)[i*m1:i*m1+m2])#length=i*13:i*13+13, Vert,NoCon; length =13*i:13*i+12 Hor,NoCon
        P[i].append(read_col(filename,2)[i*m1:i*m1+m2])##length=17*i:17*i+17, Hor,Con; length=19*i:19*i+19 Vert,Con
        Sq[i].append(read_col(filename,4)[i*m1:i*m1+m2])
        #Sn[i].append(np.zeros(np.size(x)))
    return x[0],P[0],Sq[0]

# DATA FILES FOR DIFFERENT MEASUREMENTS
filename1 = 'slitscanning_noconduit_goodresults_20161130.csv'
filename1v = 'slitscanning_vertical_noconduit_20161201_1.csv'
filename2 = 'slitscanning_results_horisontal_conduit_20160914.csv'
filename2v = 'slitscanning_vertical_15pcwidth_20161021.csv'

# DATA ARRAYS FOR DIFFERENT MEASUREMENTS
Data1 = sort_array(filename1,5,13,12)#n=7,Vert,NoCon; n=5 Hor,NoCon; n=5,Hor,Con; n=7,Vert,Con
Data1v = sort_array(filename1v,7,13,13)
Data2 = sort_array(filename2,5,17,17)
Data2v = sort_array(filename2v,7,19,19)

#horizontal scanning, no conduit
x1 = [Data1[0][i] for i in np.arange(5)]
P1 = [Data1[1][i] for i in np.arange(5)]
Sq1 = [Data1[2][i] for i in np.arange(5)]
Sn1 = np.zeros(12)
marker1 = ['-b','-g','-r','-c','-m','-y','-k']
marker11 = ['bo','g^','rv','cs','mD','yd','kp']
#marker1 = ['-p','-d','-D','-s','-v','-^','-o']
#marker11 = ['kp','yd','mD','cs','rv','g^','bo']

#Vertical scanning, no conduit
x1v = [Data1v[0][i] for i in np.arange(7)]
P1v = [Data1v[1][i] for i in np.arange(7)]
Sq1v = [Data1v[2][i] for i in np.arange(7)]
Sn1v = np.zeros(13)
marker1v = ['-b','-g','-r','-c','-m','-y','-k']
marker11v = ['bo','g^','rv','cs','mD','yd','kp']
#marker1v = ['-p','-d','-D','-s','-v','-^','-o']
#marker11v = ['kp','yd','mD','cs','rv','g^','bo']


#horizontal scanning, conduit
x2 = [Data2[0][i] for i in np.arange(5)]
P2 = [Data2[1][i] for i in np.arange(5)]
Sq2 = [Data2[2][i] for i in np.arange(5)]
Sn2 = np.zeros(17)
marker2 = ['-b','-g','-r','-c','-m','-y','-k']
marker21 = ['bo','g^','rv','cs','mD','yd','kp']

#Vertical scanning, conduit
x2v = [Data2v[0][i] for i in np.arange(7)]
P2v = [Data2v[1][i] for i in np.arange(7)]
Sq2v = [Data2v[2][i] for i in np.arange(7)]
Sn2v = np.zeros(19)
marker2v = ['-b','-g','-r','-c','-m','-y','-k']
marker21v = ['bo','g^','rv','cs','mD','yd','kp']

#Universal shot noise
Sn = np.zeros(20)
xsn = np.linspace(-0.6,0.6,20)

##PLOTTING DATA
#
#fig1 = plt.figure('Slit data, no conduit')
##plt.clf()
##plt.title('horizontal scanning, no conduit')
##plt.grid()
#
##Plotting horizontal no conduit
#ax1 = fig1.add_subplot(221)
#plt.xlabel('Distance, mm')
#plt.ylabel('Noise, dB')
#
#ax2 = ax1.twinx()
#plt.ylabel('Intensity, a.u.')
#plt.ylim(-2,4)
#
#for i in np.arange(5):
#    ax1.plot(x1[i]/1e3,Sn1,'k',label='Shot noise')
#    ax1.plot(x1[i]/1e3,Sq1[i],marker1[i],label='Squeezing')
#    ax2.plot(x1[i]/1e3, P1[i],'rd',label='Power')
#    
##Plotting vertical no conduit
#ax1 = fig1.add_subplot(222)
#plt.xlabel('Distance, mm')
#plt.ylabel('Noise, dB')
#
#ax2 = ax1.twinx()
#plt.ylabel('Intensity, a.u.')
#plt.ylim(-2,4)
#
#for i in np.arange(7):
#    ax1.plot(x1v[i]/1e3,Sn1v,'k',label='Shot noise')
#    ax1.plot(x1v[i]/1e3,Sq1v[i],marker1v[i],label='Squeezing')
#    ax2.plot(x1v[i]/1e3, P1v[i],'rd',label='Power')
#
#
##Plotting horizontal conduit
#ax1 = fig1.add_subplot(223)
#plt.xlabel('Distance, mm')
#plt.ylabel('Noise, dB')
#
#ax2 = ax1.twinx()
#plt.ylabel('Intensity, a.u.')
#plt.ylim(-2,4)
#    
#for i in np.arange(5):
#    ax1.plot(x2[i]/1e3,Sn2,'k',label='Shot noise')
#    ax1.plot(x2[i]/1e3,Sq2[i],marker2[i],label='Squeezing')
#    ax2.plot(x2[i]/1e3,P2[i],'rd',label='Power')
#
#
##Plotting vertical conduit
#ax1 = fig1.add_subplot(224)
#plt.xlabel('Distance, mm')
#plt.ylabel('Noise, dB')
#
#ax2 = ax1.twinx()
#plt.ylabel('Intensity, a.u.')
#plt.ylim(-2,4)
#
#for i in np.arange(7):
#    ax1.plot(x2v[i]/1e3,Sn2v,'k',label='Shot noise')
#    ax1.plot(x2v[i]/1e3,Sq2v[i],marker2v[i],label='Squeezing')
#    ax2.plot(x2v[i]/1e3, P2v[i],'rd',label='Power')



#FITTING AND PLOTTING THE FITTED DATA

Power1 = read_col(filename1,2)
x_value1 = read_col(filename1,0)/1e3
Power1v = read_col(filename1v,2)
x_value1v = read_col(filename1v,0)/1e3
Power2 = read_col(filename2,2)
x_value2 = read_col(filename2,0)/1e3
Power2v = read_col(filename2v,2)
x_value2v = read_col(filename2v,0)/1e3

#n = len(x_value)                          #the number of data
#mean = np.sum(x_value*Power)/n                   #note this correction
#sigma = np.sum(Power*(x_value-mean)**2)/n

#FITTING INTENSITIES
def gauss(x,a,x0,sigma,a0):
    return a*np.exp(-2*(x-x0)**2/sigma**2)+a0
    
popt1,pcov1 = curve_fit(gauss,x_value1,Power1,p0=[np.max(Power1),0.7,0.5,0.6])
print('========================================')
print('beam fit results, horizontal, no conduit')
print('========================================')
print(popt1)

popt1v,pcov1v = curve_fit(gauss,x_value1v,Power1v,p0=[np.max(Power1v),0.7,0.5,0.6])
print('========================================')
print('beam fit results, vertical, no conduit')
print('========================================')
print(popt1v)

popt2,pcov2 = curve_fit(gauss,x_value2,Power2,p0=[np.max(Power2),0.7,0.5,0.6])
print('========================================')
print('beam fit results, horizontal, conduit')
print('========================================')
print(popt2)

popt2v,pcov2v = curve_fit(gauss,x_value2v,Power2v,p0=[np.max(Power2v),0.7,0.5,0.6])
print('========================================')
print('beam fit results, vertical, conduit')
print('========================================')
print(popt2v)

#INTENSITY FUNCTION WITH FITTING PARAMETERS
x_new = np.linspace(0,1.4,200)

P_new1 = gauss(x_new,popt1[0],popt1[1],popt1[2],popt1[3])
P_new1v = gauss(x_new,popt1v[0],popt1v[1],popt1v[2],popt1v[3])
P_new2 = gauss(x_new,popt2[0],popt2[1],popt2[2],popt2[3])
P_new2v = gauss(x_new,popt2v[0],popt2v[1],popt2v[2],popt2v[3])

#ax2.plot(x_new,P_new1,'m',label='Power fit')
#ax2.plot(x_new,P_new1v,'m',label='Power fit')
#ax2.plot(x_new,P_new2,'m',label='Power fit')
#ax2.plot(x_new,P_new2v,'m',label='Power fit')


#FITTING NOISE DIPS

def gauss_inv(x,a,x0,sigma,sq):
    return a*(1-np.exp(-2*(x-x0)**2/sigma**2))+sq


x01 = [0.40,0.55,0.74,0.93,1.12]#Hor,NoCon
x01v = [0.15,0.35,0.53,0.7,0.9,1.1,1.3]#Vert,NoCon
x02 = [1.05,0.9,0.7,0.53,0.36]#Hor,Con
x02v =[1.22,1.05,0.9,0.7,0.53,0.36,0.22]#Ver,Con

#X = np.linspace(0,1.400,200)
#
##fig2 = plt.figure('Squeezing gauss fit');plt.clf()
#plt.figure('Squeezing gauss fit');plt.clf()
##plt.axes(frameon=0)
##plt.tick_params(labelleft='off')
##plt.tick_params(labelbottom='off')
#
#
#ax1 = plt.subplot(423)
#plt.xlabel('Distance, mm')
#plt.ylabel('Noise, dB')
#plt.plot(x1[3]*1e-3,Sn1,'k',label='Shot noise')
#plt.grid();
#plt.xlim(0,1.401)
##plt.ylim(-2,8)
#
#ax2 = plt.subplot(421)
#plt.title('horizontal scanning, no conduit')
#ax2.plot(x_new,P_new1,'m',label='Power fit')
#ax2.plot(x_value1,Power1,'d')
#plt.ylabel('Intensity, a.u.')
#plt.grid();plt.tick_params(labelbottom='on')
#plt.tick_params(labelleft='on')
#plt.tick_params(labelright='off')
##plt.ylim(-5,3)
#plt.xlim(0,1.401)
#
#
#for m in np.arange(5):
#    popt_inv1, pcov_inv1 = curve_fit(gauss_inv,x1[m]*1e-3,Sq1[m],p0=[np.max(Sq1[m])-np.min(Sq1[m]),x01[m],0.15,-1.0])
#    Y = gauss_inv(X,*popt_inv1)
#    ax1.plot(x1[m]*1e-3,Sq1[m],marker11[m],X,Y)
#    print popt_inv1
#
#plt.subplots_adjust(wspace=0.0)
##plt.savefig('slitscanning_horizontal_noconduit_20161130_sq_fit.png',dpi=300)
#
##def fit_squeezing(n):
##    parameters=[]
##    for i in np.arange(n):
##        popt_inv = curve_fit(gauss_inv,x[i]*1e-3,Sq[i],p0=[np.max(Sq[i])-np.min(Sq[i]),0.7,0.1,-1.2])
##        parameters.append(popt_inv)
##    return parameters
##    
##    
##PPP = fit_squeezing(7)
##plt.figure('gauss fit');plt.clf()
##plt.plot(x_value,Power,'+',label='data')
##plt.plot(x_value,gauss(x_value,*popt),'r',label='fit')
##plt.legend()
print('========================================')
print( 'Noise curves normalised to beam size')
print('========================================')

plt.figure('Squeezing gauss fit normalised',figsize = (20,11));plt.clf()



#PLOTTING AND FITTING, HORIZONTAL NO CONDUIT
ax1p = plt.subplot(425)
#ax1p.axvline(x = -0.6, linewidth=4, color='k')
#ax1p.axvline(x = 0.6, linewidth=4, color='k')
#ax1p.axhline(y = 3.0, linewidth=4, color='k')
#plt.title('horizontal scanning, no conduit, normalised')
ax1p.plot((x_new-popt1[1])/(2*popt1[2]),P_new1,'m',linewidth = 2)
ax1p.plot((x_value1-popt1[1])/(2*popt1[2]),Power1,'bd')
ax1p.plot([-0.075,0.075],[1.5,1.5],'k', linewidth = 2.5)
#y1 = (popt1[0]-popt1[3])/np.exp(2)+popt1[3]
#ax1p.plot([-0.5,0.5],[y1,y1],'k', linewidth = 2)
#plt.xlabel('Distance, mm')
plt.ylabel('Intensity, a.u.',fontsize = 20)
plt.grid();plt.tick_params(labelbottom='off')
plt.tick_params(labelleft='on')
plt.tick_params(labelright='off')
plt.yticks(np.array([0,1,2,3]), ('0.0','1.0','2.0','3.0'))
plt.text(0.5, 2.65,'b',weight = 'bold', ha='center', va='center', fontsize = 20)
plt.tick_params(labelsize = 16)
plt.ylim(-0.5,3.5)
plt.xlim(-0.601,0.601)

ax1 = plt.subplot(427)
#ax1.axvline(x = -0.6, linewidth=4, color='k')
#ax1.axvline(x = 0.6, linewidth=4, color='k')
#ax1.axhline(y = -2.0, linewidth=4, color='k')
plt.xlabel('Distance in beam size units',fontsize = 20)
plt.ylabel('Noise, dB',fontsize = 20)
#plt.plot((x1[3]*1e-3-popt1[1])/(2*popt1[2]),Sn1,'k',linewidth = 2)
plt.plot(xsn,Sn,'k',linewidth = 2)
plt.grid();
plt.yticks(np.array([-2,0,2,4]), ('-2.0','0.0','2.0','4.0'))
plt.tick_params(labelsize = 16)
plt.xlim(-0.601,0.601)
plt.ylim(-2,4.5)


X1 = np.linspace(0,1.400,200)/(2*popt1[2])
x001 = x01/(2*popt1[2])
print('========================================')
print( 'Hoizontal scanning, no conduit') 
print('========================================')
for m in np.arange(4,-1,-1):
    popt_inv1, pcov_inv1 = curve_fit(gauss_inv,x1[m]*1e-3/(2*popt1[2]),Sq1[m],p0=[np.max(Sq1[m])-np.min(Sq1[m]),x001[m],0.11,-1.0])
    Y1 = gauss_inv(X1,*popt_inv1)
    ax1.plot((x1[m]*1e-3-popt1[1])/(2*popt1[2]),Sq1[m],marker11[4-m],(X1-popt1[1]/(2*popt1[2])),Y1,marker1[4-m],linewidth = 2)
    print(popt_inv1)
    

#PLOTTING AND FITTING, VERTICAL NO CONDUIT
ax1pv = plt.subplot(426)
#ax1pv.axvline(x = -0.6, linewidth=4, color='k')
#ax1pv.axvline(x = 0.6, linewidth=4, color='k')
#ax1pv.axhline(y = -2.0, linewidth=4, color='k')
#plt.title('horizontal scanning, no conduit, normalised')
ax1pv.plot((x_new-popt1v[1])/(2*popt1v[2]),P_new1v,'m',linewidth = 2)
ax1pv.plot((x_value1v-popt1v[1])/(2*popt1v[2]),Power1v,'bd')
ax1pv.plot([-0.075,0.075],[1.5,1.5],'k', linewidth = 2.5)
#plt.xlabel('Distance, mm')
#plt.ylabel('Intensity, a.u.')
plt.grid();plt.tick_params(labelbottom='off')
plt.tick_params(labelleft='off')
plt.tick_params(labelright='off')
plt.yticks(np.array([0,1,2,3]), ('0.0','1.0','2.0','3.0'))
plt.text(0.5, 2.65,'d',weight = 'bold', ha='center', va='center', fontsize = 20)
plt.ylim(-0.5,3.5)
plt.xlim(-0.601,0.601)


ax1v = plt.subplot(428)
#ax1.axvline(x = -0.6, linewidth=4, color='k')
#ax1v.axvline(x = 0.6, linewidth=4, color='k')
#ax1v.axhline(y = -2.0, linewidth=4, color='k')
plt.xlabel('Distance in beam size units',fontsize = 20)
#plt.ylabel('Noise, dB')
#plt.plot((x1v[3]*1e-3-popt1v[1])/(2*popt1v[2]),Sn1v,'k',linewidth = 2)
plt.plot(xsn,Sn,'k',linewidth = 2)
plt.grid();plt.tick_params(labelleft='off')
plt.xticks(np.array([-0.6,-0.4,-0.2,0,0.2,0.4,0.6]), ('-0.6','-0.4','-0.2','0.0','0.2','0.4','0.6'))
plt.tick_params(labelsize = 16)
plt.yticks(np.array([-2,0,2,4]), ('-2.0','0.0','2.0','4.0'))
plt.xlim(-0.601,0.601)
plt.ylim(-2,4.5)

X1v = np.linspace(0,1.400,200)/(2*popt1v[2])
x001v = x01v/(2*popt1[2])

print('========================================')
print( 'Vertical scanning, no conduit')
print('========================================')

for m in np.arange(6,-1,-1):
    popt_inv1v, pcov_inv1v = curve_fit(gauss_inv,x1v[m]*1e-3/(2*popt1v[2]),Sq1v[m],p0=[np.max(Sq1v[m])-np.min(Sq1v[m]),x001v[m],0.11,-1.0])
    Y1v = gauss_inv(X1v,*popt_inv1v)
    ax1v.plot((x1v[m]*1e-3-popt1v[1])/(2*popt1v[2]),Sq1v[m],marker11v[6-m],(X1v-popt1v[1]/(2*popt1v[2])),Y1v,marker1v[6-m],linewidth = 2)
    print(popt_inv1v)
    #print(pcov_inv1v[2,2])

#PLOTTING AND FITTING, HORIZONTAL CONDUIT
ax2p = plt.subplot(421)
#ax2p.axvline(x = -0.6, linewidth=4, color='k')
#ax2p.axvline(x = 0.6, linewidth=4, color='k')
#ax2p.axhline(y = 4.0, linewidth=4, color='k')
#plt.title('horizontal scanning, no conduit, normalised')
ax2p.plot((x_new-popt2[1])/(2*popt2[2]),P_new2,'m',linewidth = 2)
ax2p.plot((x_value2-popt2[1])/(2*popt2[2]),Power2,'bd')
ax2p.plot([-0.075,0.075],[2,2],'k', linewidth = 2.5)
#plt.xlabel('Distance, mm')
plt.ylabel('Intensity, a.u.',fontsize = 20)
plt.grid();plt.tick_params(labelbottom='off')
plt.tick_params(labelleft='on')
plt.tick_params(labelright='off')
plt.yticks(np.array([0,1,2,3,4]), ('0.0','1.0','2.0','3.0','4.0'))
plt.text(0.5, 3.5,'a',weight = 'bold', ha='center', va='center', fontsize = 20)
plt.tick_params(labelsize = 16)
plt.ylim(-0.5,4.0)
plt.xlim(-0.601,0.601)


ax2 = plt.subplot(423)
#ax2.axvline(x = -0.6, linewidth=4, color='k')
#ax2.axvline(x = 0.6, linewidth=4, color='k')
#ax2.axhline(y = -1.2, linewidth=4, color='k')
#plt.xlabel('Distance in beam size units')
plt.ylabel('Noise, dB',fontsize = 20)
#plt.plot((x2[3]*1e-3-popt2[1])/(2*popt2[2]),Sn2,'k',linewidth = 2)
plt.plot(xsn,Sn,'k',linewidth = 2)
plt.grid();plt.tick_params(labelbottom='off')
plt.yticks(np.array([-1,0,1,2]), ('-1.0','0.0','1.0','2.0'))
plt.tick_params(labelsize = 16)
plt.xlim(-0.601,0.601)
plt.ylim(-1.2,2.7)

X2 = np.linspace(0,1.400,200)/(2*popt2[2])
x002 = x02/(2*popt2[2])

print('========================================')
print( 'Hoizontal scanning, conduit')
print('========================================')
for m in np.arange(5):
    popt_inv2, pcov_inv2 = curve_fit(gauss_inv,x2[m]*1e-3/(2*popt2[2]),Sq2[m],p0=[np.max(Sq2[m])-np.min(Sq2[m]),x002[m],0.11,-1.0])
    Y2 = gauss_inv(X2,*popt_inv2)
    ax2.plot((x2[m]*1e-3-popt2[1])/(2*popt2[2]),Sq2[m],marker21[m],(X2-popt2[1]/(2*popt2[2])),Y2,marker2[m],linewidth = 2)
    print(popt_inv2)    
    

#PLOTTING AND FITTING, VERTICAL CONDUIT
ax2pv = plt.subplot(422)
#ax2pv.axvline(x = -0.6, linewidth=4, color='k')
#ax2pv.axvline(x = 0.6, linewidth=4, color='k')
#ax2pv.axhline(y = 4.0, linewidth=4, color='k')
#plt.title('horizontal scanning, no conduit, normalised')
ax2pv.plot((x_new-popt2v[1])/(2*popt2v[2]),P_new2v,'m',linewidth = 2)
ax2pv.plot((x_value2v-popt2v[1])/(2*popt2v[2]),Power2v,'bd')
ax2pv.plot([-0.075,0.075],[2,2],'k', linewidth = 2.5)
#plt.xlabel('Distance, mm')
#plt.ylabel('Intensity, a.u.')
plt.grid();plt.tick_params(labelbottom='off')
plt.tick_params(labelleft='off')
plt.tick_params(labelright='off')
plt.yticks(np.array([0,1,2,3,4]), ('0.0','1.0','2.0','3.0','4.0'))
plt.text(0.5, 3.5,'c',weight = 'bold', ha='center', va='center', fontsize = 20)
plt.ylim(-0.5,4.0)
plt.xlim(-0.601,0.601)


ax2v = plt.subplot(424)
#ax2v.axvline(x = -0.6, linewidth=4, color='k')
#ax2v.axvline(x = 0.6, linewidth=4, color='k')
#ax2v.axhline(y = -1.2, linewidth=4, color='k')
#plt.xlabel('Distance in beam size units')
#plt.ylabel('Noise, dB')
#plt.plot((x2v[3]*1e-3-popt2v[1])/(2*popt2v[2]),Sn2v,'k',linewidth = 2)
plt.plot(xsn,Sn,'k',linewidth = 2)
plt.grid();plt.tick_params(labelbottom='off')
plt.tick_params(labelleft='off')
plt.yticks(np.array([-1,0,1,2]), ('-1.0','0.0','1.0','2.0'))
plt.ylim(-1.2,2.7)
plt.xlim(-0.601,0.601)

X2v = np.linspace(0,1.400,200)/(2*popt2v[2])
x002v = x02v/(2*popt2v[2])

print('========================================')
print( 'Vertical scanning, conduit' )   
print('========================================')
for m in np.arange(7):
    popt_inv2v, pcov_inv2v = curve_fit(gauss_inv,x2v[m][2:19]*1e-3/(2*popt2v[2]),Sq2v[m][2:19],p0=[np.max(Sq2v[m])-np.min(Sq2v[m]),x002v[m],0.15,-1.0])
    Y2v = gauss_inv(X2v,*popt_inv2v)
    ax2v.plot((x2v[m][2:19]*1e-3-popt2v[1])/(2*popt2v[2]),Sq2v[m][2:19],marker21v[m],(X2v-popt2v[1]/(2*popt2v[2])),Y2v,marker2v[m],linewidth = 2)
    print( popt_inv2v)

plt.subplots_adjust(wspace=0.05, hspace=0.02)
#plt.tight_layout(w_pad=0.01, h_pad=0.02)
#plt.savefig('slit_scanning_data_all.png',dpi=300)
#plt.savefig('slit_scanning_data_all.eps',dpi=600)

#======================================
#TROUGH WIDTHS
#======================================
cv = [0.15,0.14,0.15,0.15,0.16,0.19,0.23] #average 0.167, stdev 0.030
ch = [0.17,0.15,0.16,0.17,0.20] #average: 0.170, stdev 0.018
ncv = [0.14,0.11,0.1,0.1,0.1,0.11,0.15] #average 0.116, stdev 0.019
nch = [0.14,0.118,0.117,0.117,0.14] #average 0.128, stdev 0.010

data = np.array([np.mean(cv[0:3]),np.mean(ch[1:3]),np.mean(ncv[1:5]),np.mean(nch[1:3])])
errors = np.array([np.std(cv[0:3]),np.std(ch[1:3]),np.std(ncv[1:5]),np.std(nch[1:3])])

cases = ('CV', 'CH', 'NCV', 'NCH')
pos = np.arange(len(cases))


plt.figure('Squeezing trough widths',figsize = (10,7))
plt.clf()
plt.bar(pos, data, yerr=errors, align='center', alpha=0.5)
plt.xticks(pos, cases,fontsize = 20)
plt.ylabel('Trough width in beam size units',fontsize = 20)
plt.tick_params(labelsize = 16)
plt.show()
#plt.savefig('troughs_width.png', dpi=300)